# Copyright 2018 the V8 project authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can
# be found in the LICENSE file.

# This file is automatically generated by mkgrokdump and should not
# be modified manually.

# List of known V8 instance types.
INSTANCE_TYPES = {
  0: "INTERNALIZED_STRING_TYPE",
  2: "EXTERNAL_INTERNALIZED_STRING_TYPE",
  8: "ONE_BYTE_INTERNALIZED_STRING_TYPE",
  10: "EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  18: "EXTERNAL_INTERNALIZED_STRING_WITH_ONE_BYTE_DATA_TYPE",
  34: "UNCACHED_EXTERNAL_INTERNALIZED_STRING_TYPE",
  42: "UNCACHED_EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  50: "UNCACHED_EXTERNAL_INTERNALIZED_STRING_WITH_ONE_BYTE_DATA_TYPE",
  64: "STRING_TYPE",
  65: "CONS_STRING_TYPE",
  66: "EXTERNAL_STRING_TYPE",
  67: "SLICED_STRING_TYPE",
  69: "THIN_STRING_TYPE",
  72: "ONE_BYTE_STRING_TYPE",
  73: "CONS_ONE_BYTE_STRING_TYPE",
  74: "EXTERNAL_ONE_BYTE_STRING_TYPE",
  75: "SLICED_ONE_BYTE_STRING_TYPE",
  77: "THIN_ONE_BYTE_STRING_TYPE",
  82: "EXTERNAL_STRING_WITH_ONE_BYTE_DATA_TYPE",
  98: "UNCACHED_EXTERNAL_STRING_TYPE",
  106: "UNCACHED_EXTERNAL_ONE_BYTE_STRING_TYPE",
  114: "UNCACHED_EXTERNAL_STRING_WITH_ONE_BYTE_DATA_TYPE",
  128: "SYMBOL_TYPE",
  129: "HEAP_NUMBER_TYPE",
  130: "BIGINT_TYPE",
  131: "ODDBALL_TYPE",
  132: "MAP_TYPE",
  133: "CODE_TYPE",
  134: "MUTABLE_HEAP_NUMBER_TYPE",
  135: "FOREIGN_TYPE",
  136: "BYTE_ARRAY_TYPE",
  137: "BYTECODE_ARRAY_TYPE",
  138: "FREE_SPACE_TYPE",
  139: "FIXED_INT8_ARRAY_TYPE",
  140: "FIXED_UINT8_ARRAY_TYPE",
  141: "FIXED_INT16_ARRAY_TYPE",
  142: "FIXED_UINT16_ARRAY_TYPE",
  143: "FIXED_INT32_ARRAY_TYPE",
  144: "FIXED_UINT32_ARRAY_TYPE",
  145: "FIXED_FLOAT32_ARRAY_TYPE",
  146: "FIXED_FLOAT64_ARRAY_TYPE",
  147: "FIXED_UINT8_CLAMPED_ARRAY_TYPE",
  148: "FIXED_BIGINT64_ARRAY_TYPE",
  149: "FIXED_BIGUINT64_ARRAY_TYPE",
  150: "FIXED_DOUBLE_ARRAY_TYPE",
  151: "FEEDBACK_METADATA_TYPE",
  152: "FILLER_TYPE",
  153: "ACCESS_CHECK_INFO_TYPE",
  154: "ACCESSOR_INFO_TYPE",
  155: "ACCESSOR_PAIR_TYPE",
  156: "ALIASED_ARGUMENTS_ENTRY_TYPE",
  157: "ALLOCATION_MEMENTO_TYPE",
  158: "ASM_WASM_DATA_TYPE",
  159: "ASYNC_GENERATOR_REQUEST_TYPE",
  160: "DEBUG_INFO_TYPE",
  161: "FUNCTION_TEMPLATE_INFO_TYPE",
  162: "FUNCTION_TEMPLATE_RARE_DATA_TYPE",
  163: "INTERCEPTOR_INFO_TYPE",
  164: "INTERPRETER_DATA_TYPE",
  165: "MODULE_INFO_ENTRY_TYPE",
  166: "MODULE_TYPE",
  167: "OBJECT_TEMPLATE_INFO_TYPE",
  168: "PROMISE_CAPABILITY_TYPE",
  169: "PROMISE_REACTION_TYPE",
  170: "PROTOTYPE_INFO_TYPE",
  171: "SCRIPT_TYPE",
  172: "STACK_FRAME_INFO_TYPE",
  173: "TUPLE2_TYPE",
  174: "TUPLE3_TYPE",
  175: "ARRAY_BOILERPLATE_DESCRIPTION_TYPE",
  176: "WASM_DEBUG_INFO_TYPE",
  177: "WASM_EXCEPTION_TAG_TYPE",
  178: "WASM_EXPORTED_FUNCTION_DATA_TYPE",
  179: "CALLABLE_TASK_TYPE",
  180: "CALLBACK_TASK_TYPE",
  181: "PROMISE_FULFILL_REACTION_JOB_TASK_TYPE",
  182: "PROMISE_REJECT_REACTION_JOB_TASK_TYPE",
  183: "PROMISE_RESOLVE_THENABLE_JOB_TASK_TYPE",
  184: "WEAK_FACTORY_CLEANUP_JOB_TASK_TYPE",
  185: "ALLOCATION_SITE_TYPE",
  186: "EMBEDDER_DATA_ARRAY_TYPE",
  187: "FIXED_ARRAY_TYPE",
  188: "OBJECT_BOILERPLATE_DESCRIPTION_TYPE",
  189: "HASH_TABLE_TYPE",
  190: "ORDERED_HASH_MAP_TYPE",
  191: "ORDERED_HASH_SET_TYPE",
  192: "ORDERED_NAME_DICTIONARY_TYPE",
  193: "NAME_DICTIONARY_TYPE",
  194: "GLOBAL_DICTIONARY_TYPE",
  195: "NUMBER_DICTIONARY_TYPE",
  196: "SIMPLE_NUMBER_DICTIONARY_TYPE",
  197: "STRING_TABLE_TYPE",
  198: "EPHEMERON_HASH_TABLE_TYPE",
  199: "SCOPE_INFO_TYPE",
  200: "SCRIPT_CONTEXT_TABLE_TYPE",
  201: "AWAIT_CONTEXT_TYPE",
  202: "BLOCK_CONTEXT_TYPE",
  203: "CATCH_CONTEXT_TYPE",
  204: "DEBUG_EVALUATE_CONTEXT_TYPE",
  205: "EVAL_CONTEXT_TYPE",
  206: "FUNCTION_CONTEXT_TYPE",
  207: "MODULE_CONTEXT_TYPE",
  208: "NATIVE_CONTEXT_TYPE",
  209: "SCRIPT_CONTEXT_TYPE",
  210: "WITH_CONTEXT_TYPE",
  211: "WEAK_FIXED_ARRAY_TYPE",
  212: "TRANSITION_ARRAY_TYPE",
  213: "CALL_HANDLER_INFO_TYPE",
  214: "CELL_TYPE",
  215: "CODE_DATA_CONTAINER_TYPE",
  216: "DESCRIPTOR_ARRAY_TYPE",
  217: "FEEDBACK_CELL_TYPE",
  218: "FEEDBACK_VECTOR_TYPE",
  219: "LOAD_HANDLER_TYPE",
  220: "PREPARSE_DATA_TYPE",
  221: "PROPERTY_ARRAY_TYPE",
  222: "PROPERTY_CELL_TYPE",
  223: "SHARED_FUNCTION_INFO_TYPE",
  224: "SMALL_ORDERED_HASH_MAP_TYPE",
  225: "SMALL_ORDERED_HASH_SET_TYPE",
  226: "SMALL_ORDERED_NAME_DICTIONARY_TYPE",
  227: "STORE_HANDLER_TYPE",
  228: "UNCOMPILED_DATA_WITHOUT_PREPARSE_DATA_TYPE",
  229: "UNCOMPILED_DATA_WITH_PREPARSE_DATA_TYPE",
  230: "WEAK_ARRAY_LIST_TYPE",
  1024: "JS_PROXY_TYPE",
  1025: "JS_GLOBAL_OBJECT_TYPE",
  1026: "JS_GLOBAL_PROXY_TYPE",
  1027: "JS_MODULE_NAMESPACE_TYPE",
  1040: "JS_SPECIAL_API_OBJECT_TYPE",
  1041: "JS_VALUE_TYPE",
  1056: "JS_API_OBJECT_TYPE",
  1057: "JS_OBJECT_TYPE",
  1058: "JS_ARGUMENTS_TYPE",
  1059: "JS_ARRAY_BUFFER_TYPE",
  1060: "JS_ARRAY_ITERATOR_TYPE",
  1061: "JS_ARRAY_TYPE",
  1062: "JS_ASYNC_FROM_SYNC_ITERATOR_TYPE",
  1063: "JS_ASYNC_FUNCTION_OBJECT_TYPE",
  1064: "JS_ASYNC_GENERATOR_OBJECT_TYPE",
  1065: "JS_CONTEXT_EXTENSION_OBJECT_TYPE",
  1066: "JS_DATE_TYPE",
  1067: "JS_ERROR_TYPE",
  1068: "JS_GENERATOR_OBJECT_TYPE",
  1069: "JS_MAP_TYPE",
  1070: "JS_MAP_KEY_ITERATOR_TYPE",
  1071: "JS_MAP_KEY_VALUE_ITERATOR_TYPE",
  1072: "JS_MAP_VALUE_ITERATOR_TYPE",
  1073: "JS_MESSAGE_OBJECT_TYPE",
  1074: "JS_PROMISE_TYPE",
  1075: "JS_REGEXP_TYPE",
  1076: "JS_REGEXP_STRING_ITERATOR_TYPE",
  1077: "JS_SET_TYPE",
  1078: "JS_SET_KEY_VALUE_ITERATOR_TYPE",
  1079: "JS_SET_VALUE_ITERATOR_TYPE",
  1080: "JS_STRING_ITERATOR_TYPE",
  1081: "JS_WEAK_CELL_TYPE",
  1082: "JS_WEAK_REF_TYPE",
  1083: "JS_WEAK_FACTORY_CLEANUP_ITERATOR_TYPE",
  1084: "JS_WEAK_FACTORY_TYPE",
  1085: "JS_WEAK_MAP_TYPE",
  1086: "JS_WEAK_SET_TYPE",
  1087: "JS_TYPED_ARRAY_TYPE",
  1088: "JS_DATA_VIEW_TYPE",
  1089: "JS_INTL_V8_BREAK_ITERATOR_TYPE",
  1090: "JS_INTL_COLLATOR_TYPE",
  1091: "JS_INTL_DATE_TIME_FORMAT_TYPE",
  1092: "JS_INTL_LIST_FORMAT_TYPE",
  1093: "JS_INTL_LOCALE_TYPE",
  1094: "JS_INTL_NUMBER_FORMAT_TYPE",
  1095: "JS_INTL_PLURAL_RULES_TYPE",
  1096: "JS_INTL_RELATIVE_TIME_FORMAT_TYPE",
  1097: "JS_INTL_SEGMENT_ITERATOR_TYPE",
  1098: "JS_INTL_SEGMENTER_TYPE",
  1099: "WASM_EXCEPTION_TYPE",
  1100: "WASM_GLOBAL_TYPE",
  1101: "WASM_INSTANCE_TYPE",
  1102: "WASM_MEMORY_TYPE",
  1103: "WASM_MODULE_TYPE",
  1104: "WASM_TABLE_TYPE",
  1105: "JS_BOUND_FUNCTION_TYPE",
  1106: "JS_FUNCTION_TYPE",
}

# List of known V8 maps.
KNOWN_MAPS = {
  ("RO_SPACE", 0x00131): (138, "FreeSpaceMap"),
  ("RO_SPACE", 0x00181): (132, "MetaMap"),
  ("RO_SPACE", 0x00201): (131, "NullMap"),
  ("RO_SPACE", 0x00269): (216, "DescriptorArrayMap"),
  ("RO_SPACE", 0x002c9): (211, "WeakFixedArrayMap"),
  ("RO_SPACE", 0x00319): (152, "OnePointerFillerMap"),
  ("RO_SPACE", 0x00369): (152, "TwoPointerFillerMap"),
  ("RO_SPACE", 0x003e9): (131, "UninitializedMap"),
  ("RO_SPACE", 0x00459): (8, "OneByteInternalizedStringMap"),
  ("RO_SPACE", 0x004f9): (131, "UndefinedMap"),
  ("RO_SPACE", 0x00559): (129, "HeapNumberMap"),
  ("RO_SPACE", 0x005d9): (131, "TheHoleMap"),
  ("RO_SPACE", 0x00681): (131, "BooleanMap"),
  ("RO_SPACE", 0x00759): (136, "ByteArrayMap"),
  ("RO_SPACE", 0x007a9): (187, "FixedArrayMap"),
  ("RO_SPACE", 0x007f9): (187, "FixedCOWArrayMap"),
  ("RO_SPACE", 0x00849): (189, "HashTableMap"),
  ("RO_SPACE", 0x00899): (128, "SymbolMap"),
  ("RO_SPACE", 0x008e9): (72, "OneByteStringMap"),
  ("RO_SPACE", 0x00939): (199, "ScopeInfoMap"),
  ("RO_SPACE", 0x00989): (223, "SharedFunctionInfoMap"),
  ("RO_SPACE", 0x009d9): (133, "CodeMap"),
  ("RO_SPACE", 0x00a29): (206, "FunctionContextMap"),
  ("RO_SPACE", 0x00a79): (214, "CellMap"),
  ("RO_SPACE", 0x00ac9): (222, "GlobalPropertyCellMap"),
  ("RO_SPACE", 0x00b19): (135, "ForeignMap"),
  ("RO_SPACE", 0x00b69): (212, "TransitionArrayMap"),
  ("RO_SPACE", 0x00bb9): (218, "FeedbackVectorMap"),
  ("RO_SPACE", 0x00c59): (131, "ArgumentsMarkerMap"),
  ("RO_SPACE", 0x00cf9): (131, "ExceptionMap"),
  ("RO_SPACE", 0x00d99): (131, "TerminationExceptionMap"),
  ("RO_SPACE", 0x00e41): (131, "OptimizedOutMap"),
  ("RO_SPACE", 0x00ee1): (131, "StaleRegisterMap"),
  ("RO_SPACE", 0x00f51): (208, "NativeContextMap"),
  ("RO_SPACE", 0x00fa1): (207, "ModuleContextMap"),
  ("RO_SPACE", 0x00ff1): (205, "EvalContextMap"),
  ("RO_SPACE", 0x01041): (209, "ScriptContextMap"),
  ("RO_SPACE", 0x01091): (201, "AwaitContextMap"),
  ("RO_SPACE", 0x010e1): (202, "BlockContextMap"),
  ("RO_SPACE", 0x01131): (203, "CatchContextMap"),
  ("RO_SPACE", 0x01181): (210, "WithContextMap"),
  ("RO_SPACE", 0x011d1): (204, "DebugEvaluateContextMap"),
  ("RO_SPACE", 0x01221): (200, "ScriptContextTableMap"),
  ("RO_SPACE", 0x01271): (151, "FeedbackMetadataArrayMap"),
  ("RO_SPACE", 0x012c1): (187, "ArrayListMap"),
  ("RO_SPACE", 0x01311): (130, "BigIntMap"),
  ("RO_SPACE", 0x01361): (188, "ObjectBoilerplateDescriptionMap"),
  ("RO_SPACE", 0x013b1): (137, "BytecodeArrayMap"),
  ("RO_SPACE", 0x01401): (215, "CodeDataContainerMap"),
  ("RO_SPACE", 0x01451): (150, "FixedDoubleArrayMap"),
  ("RO_SPACE", 0x014a1): (194, "GlobalDictionaryMap"),
  ("RO_SPACE", 0x014f1): (217, "ManyClosuresCellMap"),
  ("RO_SPACE", 0x01541): (187, "ModuleInfoMap"),
  ("RO_SPACE", 0x01591): (134, "MutableHeapNumberMap"),
  ("RO_SPACE", 0x015e1): (193, "NameDictionaryMap"),
  ("RO_SPACE", 0x01631): (217, "NoClosuresCellMap"),
  ("RO_SPACE", 0x01681): (217, "NoFeedbackCellMap"),
  ("RO_SPACE", 0x016d1): (195, "NumberDictionaryMap"),
  ("RO_SPACE", 0x01721): (217, "OneClosureCellMap"),
  ("RO_SPACE", 0x01771): (190, "OrderedHashMapMap"),
  ("RO_SPACE", 0x017c1): (191, "OrderedHashSetMap"),
  ("RO_SPACE", 0x01811): (192, "OrderedNameDictionaryMap"),
  ("RO_SPACE", 0x01861): (220, "PreparseDataMap"),
  ("RO_SPACE", 0x018b1): (221, "PropertyArrayMap"),
  ("RO_SPACE", 0x01901): (213, "SideEffectCallHandlerInfoMap"),
  ("RO_SPACE", 0x01951): (213, "SideEffectFreeCallHandlerInfoMap"),
  ("RO_SPACE", 0x019a1): (213, "NextCallSideEffectFreeCallHandlerInfoMap"),
  ("RO_SPACE", 0x019f1): (196, "SimpleNumberDictionaryMap"),
  ("RO_SPACE", 0x01a41): (187, "SloppyArgumentsElementsMap"),
  ("RO_SPACE", 0x01a91): (224, "SmallOrderedHashMapMap"),
  ("RO_SPACE", 0x01ae1): (225, "SmallOrderedHashSetMap"),
  ("RO_SPACE", 0x01b31): (226, "SmallOrderedNameDictionaryMap"),
  ("RO_SPACE", 0x01b81): (197, "StringTableMap"),
  ("RO_SPACE", 0x01bd1): (228, "UncompiledDataWithoutPreparseDataMap"),
  ("RO_SPACE", 0x01c21): (229, "UncompiledDataWithPreparseDataMap"),
  ("RO_SPACE", 0x01c71): (230, "WeakArrayListMap"),
  ("RO_SPACE", 0x01cc1): (198, "EphemeronHashTableMap"),
  ("RO_SPACE", 0x01d11): (186, "EmbedderDataArrayMap"),
  ("RO_SPACE", 0x01d61): (106, "NativeSourceStringMap"),
  ("RO_SPACE", 0x01db1): (64, "StringMap"),
  ("RO_SPACE", 0x01e01): (73, "ConsOneByteStringMap"),
  ("RO_SPACE", 0x01e51): (65, "ConsStringMap"),
  ("RO_SPACE", 0x01ea1): (77, "ThinOneByteStringMap"),
  ("RO_SPACE", 0x01ef1): (69, "ThinStringMap"),
  ("RO_SPACE", 0x01f41): (67, "SlicedStringMap"),
  ("RO_SPACE", 0x01f91): (75, "SlicedOneByteStringMap"),
  ("RO_SPACE", 0x01fe1): (66, "ExternalStringMap"),
  ("RO_SPACE", 0x02031): (82, "ExternalStringWithOneByteDataMap"),
  ("RO_SPACE", 0x02081): (74, "ExternalOneByteStringMap"),
  ("RO_SPACE", 0x020d1): (98, "UncachedExternalStringMap"),
  ("RO_SPACE", 0x02121): (114, "UncachedExternalStringWithOneByteDataMap"),
  ("RO_SPACE", 0x02171): (0, "InternalizedStringMap"),
  ("RO_SPACE", 0x021c1): (2, "ExternalInternalizedStringMap"),
  ("RO_SPACE", 0x02211): (18, "ExternalInternalizedStringWithOneByteDataMap"),
  ("RO_SPACE", 0x02261): (10, "ExternalOneByteInternalizedStringMap"),
  ("RO_SPACE", 0x022b1): (34, "UncachedExternalInternalizedStringMap"),
  ("RO_SPACE", 0x02301): (50, "UncachedExternalInternalizedStringWithOneByteDataMap"),
  ("RO_SPACE", 0x02351): (42, "UncachedExternalOneByteInternalizedStringMap"),
  ("RO_SPACE", 0x023a1): (106, "UncachedExternalOneByteStringMap"),
  ("RO_SPACE", 0x023f1): (140, "FixedUint8ArrayMap"),
  ("RO_SPACE", 0x02441): (139, "FixedInt8ArrayMap"),
  ("RO_SPACE", 0x02491): (142, "FixedUint16ArrayMap"),
  ("RO_SPACE", 0x024e1): (141, "FixedInt16ArrayMap"),
  ("RO_SPACE", 0x02531): (144, "FixedUint32ArrayMap"),
  ("RO_SPACE", 0x02581): (143, "FixedInt32ArrayMap"),
  ("RO_SPACE", 0x025d1): (145, "FixedFloat32ArrayMap"),
  ("RO_SPACE", 0x02621): (146, "FixedFloat64ArrayMap"),
  ("RO_SPACE", 0x02671): (147, "FixedUint8ClampedArrayMap"),
  ("RO_SPACE", 0x026c1): (149, "FixedBigUint64ArrayMap"),
  ("RO_SPACE", 0x02711): (148, "FixedBigInt64ArrayMap"),
  ("RO_SPACE", 0x02761): (131, "SelfReferenceMarkerMap"),
  ("RO_SPACE", 0x027c9): (173, "Tuple2Map"),
  ("RO_SPACE", 0x02869): (175, "ArrayBoilerplateDescriptionMap"),
  ("RO_SPACE", 0x02ba9): (163, "InterceptorInfoMap"),
  ("RO_SPACE", 0x050c9): (153, "AccessCheckInfoMap"),
  ("RO_SPACE", 0x05119): (154, "AccessorInfoMap"),
  ("RO_SPACE", 0x05169): (155, "AccessorPairMap"),
  ("RO_SPACE", 0x051b9): (156, "AliasedArgumentsEntryMap"),
  ("RO_SPACE", 0x05209): (157, "AllocationMementoMap"),
  ("RO_SPACE", 0x05259): (158, "AsmWasmDataMap"),
  ("RO_SPACE", 0x052a9): (159, "AsyncGeneratorRequestMap"),
  ("RO_SPACE", 0x052f9): (160, "DebugInfoMap"),
  ("RO_SPACE", 0x05349): (161, "FunctionTemplateInfoMap"),
  ("RO_SPACE", 0x05399): (162, "FunctionTemplateRareDataMap"),
  ("RO_SPACE", 0x053e9): (164, "InterpreterDataMap"),
  ("RO_SPACE", 0x05439): (165, "ModuleInfoEntryMap"),
  ("RO_SPACE", 0x05489): (166, "ModuleMap"),
  ("RO_SPACE", 0x054d9): (167, "ObjectTemplateInfoMap"),
  ("RO_SPACE", 0x05529): (168, "PromiseCapabilityMap"),
  ("RO_SPACE", 0x05579): (169, "PromiseReactionMap"),
  ("RO_SPACE", 0x055c9): (170, "PrototypeInfoMap"),
  ("RO_SPACE", 0x05619): (171, "ScriptMap"),
  ("RO_SPACE", 0x05669): (172, "StackFrameInfoMap"),
  ("RO_SPACE", 0x056b9): (174, "Tuple3Map"),
  ("RO_SPACE", 0x05709): (176, "WasmDebugInfoMap"),
  ("RO_SPACE", 0x05759): (177, "WasmExceptionTagMap"),
  ("RO_SPACE", 0x057a9): (178, "WasmExportedFunctionDataMap"),
  ("RO_SPACE", 0x057f9): (179, "CallableTaskMap"),
  ("RO_SPACE", 0x05849): (180, "CallbackTaskMap"),
  ("RO_SPACE", 0x05899): (181, "PromiseFulfillReactionJobTaskMap"),
  ("RO_SPACE", 0x058e9): (182, "PromiseRejectReactionJobTaskMap"),
  ("RO_SPACE", 0x05939): (183, "PromiseResolveThenableJobTaskMap"),
  ("RO_SPACE", 0x05989): (184, "WeakFactoryCleanupJobTaskMap"),
  ("RO_SPACE", 0x059d9): (185, "AllocationSiteWithWeakNextMap"),
  ("RO_SPACE", 0x05a29): (185, "AllocationSiteWithoutWeakNextMap"),
  ("RO_SPACE", 0x05a79): (219, "LoadHandler1Map"),
  ("RO_SPACE", 0x05ac9): (219, "LoadHandler2Map"),
  ("RO_SPACE", 0x05b19): (219, "LoadHandler3Map"),
  ("RO_SPACE", 0x05b69): (227, "StoreHandler0Map"),
  ("RO_SPACE", 0x05bb9): (227, "StoreHandler1Map"),
  ("RO_SPACE", 0x05c09): (227, "StoreHandler2Map"),
  ("RO_SPACE", 0x05c59): (227, "StoreHandler3Map"),
  ("MAP_SPACE", 0x00131): (1057, "ExternalMap"),
  ("MAP_SPACE", 0x00181): (1073, "JSMessageObjectMap"),
}

# List of known V8 objects.
KNOWN_OBJECTS = {
  ("RO_SPACE", 0x001d1): "NullValue",
  ("RO_SPACE", 0x00251): "EmptyDescriptorArray",
  ("RO_SPACE", 0x002b9): "EmptyWeakFixedArray",
  ("RO_SPACE", 0x003b9): "UninitializedValue",
  ("RO_SPACE", 0x004c9): "UndefinedValue",
  ("RO_SPACE", 0x00549): "NanValue",
  ("RO_SPACE", 0x005a9): "TheHoleValue",
  ("RO_SPACE", 0x00641): "HoleNanValue",
  ("RO_SPACE", 0x00651): "TrueValue",
  ("RO_SPACE", 0x00701): "FalseValue",
  ("RO_SPACE", 0x00749): "empty_string",
  ("RO_SPACE", 0x00c09): "EmptyScopeInfo",
  ("RO_SPACE", 0x00c19): "EmptyFixedArray",
  ("RO_SPACE", 0x00c29): "ArgumentsMarker",
  ("RO_SPACE", 0x00cc9): "Exception",
  ("RO_SPACE", 0x00d69): "TerminationException",
  ("RO_SPACE", 0x00e11): "OptimizedOut",
  ("RO_SPACE", 0x00eb1): "StaleRegister",
  ("RO_SPACE", 0x027b1): "EmptyEnumCache",
  ("RO_SPACE", 0x02819): "EmptyPropertyArray",
  ("RO_SPACE", 0x02829): "EmptyByteArray",
  ("RO_SPACE", 0x02839): "EmptyObjectBoilerplateDescription",
  ("RO_SPACE", 0x02851): "EmptyArrayBoilerplateDescription",
  ("RO_SPACE", 0x028b9): "EmptyFixedUint8Array",
  ("RO_SPACE", 0x028d9): "EmptyFixedInt8Array",
  ("RO_SPACE", 0x028f9): "EmptyFixedUint16Array",
  ("RO_SPACE", 0x02919): "EmptyFixedInt16Array",
  ("RO_SPACE", 0x02939): "EmptyFixedUint32Array",
  ("RO_SPACE", 0x02959): "EmptyFixedInt32Array",
  ("RO_SPACE", 0x02979): "EmptyFixedFloat32Array",
  ("RO_SPACE", 0x02999): "EmptyFixedFloat64Array",
  ("RO_SPACE", 0x029b9): "EmptyFixedUint8ClampedArray",
  ("RO_SPACE", 0x029d9): "EmptyFixedBigUint64Array",
  ("RO_SPACE", 0x029f9): "EmptyFixedBigInt64Array",
  ("RO_SPACE", 0x02a19): "EmptySloppyArgumentsElements",
  ("RO_SPACE", 0x02a39): "EmptySlowElementDictionary",
  ("RO_SPACE", 0x02a81): "EmptyOrderedHashMap",
  ("RO_SPACE", 0x02aa9): "EmptyOrderedHashSet",
  ("RO_SPACE", 0x02ad1): "EmptyFeedbackMetadata",
  ("RO_SPACE", 0x02ae1): "EmptyPropertyCell",
  ("RO_SPACE", 0x02b09): "EmptyPropertyDictionary",
  ("RO_SPACE", 0x02b59): "NoOpInterceptorInfo",
  ("RO_SPACE", 0x02bf9): "EmptyWeakArrayList",
  ("RO_SPACE", 0x02c11): "InfinityValue",
  ("RO_SPACE", 0x02c21): "MinusZeroValue",
  ("RO_SPACE", 0x02c31): "MinusInfinityValue",
  ("RO_SPACE", 0x02c41): "SelfReferenceMarker",
  ("RO_SPACE", 0x02c99): "OffHeapTrampolineRelocationInfo",
  ("RO_SPACE", 0x02cb1): "HashSeed",
  ("OLD_SPACE", 0x00131): "ArgumentsIteratorAccessor",
  ("OLD_SPACE", 0x001a1): "ArrayLengthAccessor",
  ("OLD_SPACE", 0x00211): "BoundFunctionLengthAccessor",
  ("OLD_SPACE", 0x00281): "BoundFunctionNameAccessor",
  ("OLD_SPACE", 0x002f1): "ErrorStackAccessor",
  ("OLD_SPACE", 0x00361): "FunctionArgumentsAccessor",
  ("OLD_SPACE", 0x003d1): "FunctionCallerAccessor",
  ("OLD_SPACE", 0x00441): "FunctionNameAccessor",
  ("OLD_SPACE", 0x004b1): "FunctionLengthAccessor",
  ("OLD_SPACE", 0x00521): "FunctionPrototypeAccessor",
  ("OLD_SPACE", 0x00591): "StringLengthAccessor",
  ("OLD_SPACE", 0x00601): "InvalidPrototypeValidityCell",
  ("OLD_SPACE", 0x00611): "EmptyScript",
  ("OLD_SPACE", 0x00691): "ManyClosuresCell",
  ("OLD_SPACE", 0x006a1): "NoFeedbackCell",
  ("OLD_SPACE", 0x006b1): "ArrayConstructorProtector",
  ("OLD_SPACE", 0x006c1): "NoElementsProtector",
  ("OLD_SPACE", 0x006e9): "IsConcatSpreadableProtector",
  ("OLD_SPACE", 0x006f9): "ArraySpeciesProtector",
  ("OLD_SPACE", 0x00721): "TypedArraySpeciesProtector",
  ("OLD_SPACE", 0x00749): "RegExpSpeciesProtector",
  ("OLD_SPACE", 0x00771): "PromiseSpeciesProtector",
  ("OLD_SPACE", 0x00799): "StringLengthProtector",
  ("OLD_SPACE", 0x007a9): "ArrayIteratorProtector",
  ("OLD_SPACE", 0x007d1): "ArrayBufferDetachingProtector",
  ("OLD_SPACE", 0x007f9): "PromiseHookProtector",
  ("OLD_SPACE", 0x00821): "PromiseResolveProtector",
  ("OLD_SPACE", 0x00831): "MapIteratorProtector",
  ("OLD_SPACE", 0x00859): "PromiseThenProtector",
  ("OLD_SPACE", 0x00881): "SetIteratorProtector",
  ("OLD_SPACE", 0x008a9): "StringIteratorProtector",
  ("OLD_SPACE", 0x008d1): "SingleCharacterStringCache",
  ("OLD_SPACE", 0x010e1): "StringSplitCache",
  ("OLD_SPACE", 0x018f1): "RegExpMultipleCache",
  ("OLD_SPACE", 0x02101): "BuiltinsConstantsTable",
}

# List of known V8 Frame Markers.
FRAME_MARKERS = (
  "ENTRY",
  "CONSTRUCT_ENTRY",
  "EXIT",
  "OPTIMIZED",
  "WASM_COMPILED",
  "WASM_TO_JS",
  "JS_TO_WASM",
  "WASM_INTERPRETER_ENTRY",
  "C_WASM_ENTRY",
  "WASM_COMPILE_LAZY",
  "INTERPRETED",
  "STUB",
  "BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION_WITH_CATCH",
  "INTERNAL",
  "CONSTRUCT",
  "ARGUMENTS_ADAPTOR",
  "BUILTIN",
  "BUILTIN_EXIT",
  "NATIVE",
)

# This set of constants is generated from a shipping build.
